%This function estimates parameters for a model (tbfModel: handle in
%arguments)
%It returns best-fitting parameters and the minimum function value

function [x,fVal,exitflag] = wrapper4VPfmin(pArray, Data, expParms, tbfModel)

% setup the precision in wrapper
if expParms.fitting == 1
    option = optimset('Display','off','TolFun',1e-10, 'FunValCheck','on', 'MaxIter', 5000);
    [x,fVal,exitflag] = fminsearchbnd(@bof, pArray, expParms.llim, expParms.ulim, option); 
end
if expParms.fitting == 2
    option = gaoptimset('MutationFcn', @mutationadaptfeasible); 
    [x,fVal,exitflag] = ga(@bof, expParms.npar, [], [], [], [], expParms.llim, expParms.ulim, [], option);
end
if expParms.fitting == 3
    option = psoptimset(@patternsearch);
    [x, fVal,exitflag] = patternsearch(@bof, pArray, [], [], [], [], expParms.llim, expParms.ulim, [], option);
end

%nested function 'bof' inherits 'data' and argument 'parms'
%is provided by fminsearch
    function logL=bof(parms)     
        likelihood = tbfModel(parms, Data, expParms);
        if min(min(likelihood)) < 0, logL = 100000; else logL = -sum(2*log(likelihood)); end %safeguard because in MM2, likelihoods can go negative if Ci+Ai > 1
    end                         
end

