%This function estimates parameters for a model (tbfModel: handle in
%arguments)
%It returns best-fitting parameters and the minimum function value

function [x,fVal] = wrapper4fmin(pArray, Data, expParms, tbfModel)

[x,fVal] = fminsearchbnd(@bof, pArray, expParms.llim, expParms.ulim); 

%nested function 'bof' inherits 'data' and argument 'parms'
%is provided by fminsearch
    function logL=bof(parms)     
        Pred=tbfModel(parms, Data, expParms);   %the model predictions are a probability density over all colors (= angles in color wheel), for each trial
        I = repmat(1:360, expParms.N, 1);
        D = repmat(Data.response, 1, 360);
        Index = I == D; %for each trial (rows), Index is 1 in the xth column, where x is the actually selected color in that trial, and zero otherwise
        likelihood = Pred(Index);      %Data codes the responses (i.e., the selected color angle), serving as index into the prob-distribution
        if min(min(likelihood)) < 0, logL = 100000; else logL = -sum(2*log(likelihood)); end %safeguard because in MM2, likelihoods can go negative if Ci+Ai > 1
        s = 1;  %the loop variable to be used in the constraint (below) must be initialized (for some reason...)
        eval(expParms.constraint); 
    end                         
end

